public class AffineTransform {
/** Trasformazione affine in dimensione 2, definita da una matrice A e da
una coppia (b) di termini noti; (y) = A * (x) + (b)   */

       private Matrix A;
       private Couple translation;

       public AffineTransform(){
              A=new Matrix();
              translation=new Couple();
       }
       public AffineTransform(double a,double b,double c,double d,double e,double f) {
              A=new Matrix(a,b,c,d);
              translation=new Couple(e,f);
       }
       /** Trova la trasformazione affine che trasforma p in u, q in v, r in w */
       public AffineTransform(Couple p,Couple q,Couple r,Couple u,Couple v,Couple w) {
              Couple u1,u2,v1,v2,t;
              // trovo i vettori liberi
              u1=new Couple(q.x-p.x , q.y-p.y);
              u2=new Couple(r.x-p.x , r.y-p.y);
              v1=new Couple(v.x-u.x , v.y-u.y);
              v2=new Couple(w.x-u.x , w.y-u.y);

              A=new Matrix( new Matrix(v1,v2),new Matrix(u1,u2).inverse() );
              translation = new Couple();
              t = new Couple(A,p);
              translation.x = u.x - t.x;
              translation.y = u.y - t.y;
       }

       public Couple transform (Couple in){
       return new Couple(A.a*in.x + A.b*in.y + translation.x,
                         A.c*in.x + A.d*in.y + translation.y);
       }
}