import java.awt.Canvas;
import java.awt.Graphics;
import java.awt.Dimension;

public class IFSGen extends Canvas implements Runnable {
			 private static final boolean DEBUG = false;
       private static final int MAXTRANSF = 20;
       private int width = 200;
       private int height = 200;
       
       public IFSImage img = new IFSImage();
       public boolean drawing = false;
       public int NITERATIONS = 5000;

       private AffineTransform adapt2Video;
       private double p[]= new double[MAXTRANSF];  // tabella delle probabilit;
       
       public void init(int width,int height){
              Couple p,q,r,u,v,w;
              setSize(width,height);
              this.width=width;
              this.height=height;
              p = new Couple(); p = img.leftbottom;
              q = new Couple(); q = img.righttop;
              r = new Couple(img.leftbottom.x,img.righttop.y);
              u = new Couple(0,height);
              v = new Couple(width,0);
              w = new Couple(0,0);
              adapt2Video = new AffineTransform(p,q,r,u,v,w);
       }
       
       public void setSize(int w,int h){
       	super.setSize(w,h);
       	width=w;
       	height=h;
       }
       
		 public final synchronized void clear(){
		 	Graphics g = getGraphics();
		 	g.setColor(getBackground());
		 	g.fillRect(0,0,width,height);
		 	
		 }

		 public void update(Graphics g){
		 	// do nothing
		 }
		 
		 public synchronized void run(){
		 	     Graphics g = getGraphics();
              double r;     // numero casuale
              int c=0;      // contatore
              Couple pt=new Couple();
              Couple newpt,videopt;
              int videox,videoy;
              IFSItem curItem=new IFSItem();
              
              System.out.println ("Painting image "+img.title);
              drawing = true;

          // Creo tabella probabilit
          		 curItem = (IFSItem) img.code.elementAt(0);
          		 p[0]=curItem.prob;
          		      //debug("Prob table:\n" + p[0]);
              for (int j=1; j<img.code.size(); j++) {
                  curItem=(IFSItem) img.code.elementAt(j);
                  p[j]=p[j-1] + curItem.prob;
                    //debug(p[j]);
              }

          // Produco l'immagine
              g.setColor(img.color);
              for (int i=0; i<NITERATIONS; i++) {
                  r=Math.random();
                    //debug("Random number = " + r);
                  while (c<(img.code.size()-1) & r>p[c]) c++;
                    //debug("Using affine transform #"+ (c+1));
                  curItem=(IFSItem) img.code.elementAt(c);
                  c=0;
                  newpt=curItem.transf.transform(pt);
                    //debug(pt + " trasformed to " + newpt);
                  videopt=adapt2Video.transform(newpt);
                  videox=(int) Math.round(videopt.x);
                  videoy=(int) Math.round(videopt.y);
                  g.drawRect(videox,videoy,0,0);
                    //debug("Drawing to video " + videox + " , " + videoy + "\n");
                  pt.x=newpt.x;
                  pt.y=newpt.y;
              }
              System.out.println("\nImage complete");
              drawing = false;
       }
       
       public Dimension getPreferredSize(){
       	return new Dimension(width,height);
       }
       
       private final void debug(String msg){
       	if (DEBUG) System.out.println(msg);
       }
       private final void debug(double n){
       	if (DEBUG) System.out.println(n);
       }

}
